﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinToolbars;

namespace RightAlignAppMenuTextEditor90602
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.Load += new EventHandler(Form1_Load);
        }

        void Form1_Load(object sender, EventArgs e)
        {
            ultraToolbarsManager1.CreationFilter = new ApplicationMenuCreationFilter();

            //Desired width of the ApplicationMenu's ToolLeftArea
            ultraToolbarsManager1.Ribbon.ApplicationMenu.ToolAreaLeft.MinWidth = 380;
            //Desired width of the textEditor
            (ultraToolbarsManager1.CreationFilter as ApplicationMenuCreationFilter).textEditorWidth = 250;
        }

        private class ApplicationMenuCreationFilter : IUIElementCreationFilter
        {
            int LeftToolsAreaRightBorder;
            public int textEditorWidth { get; set; }

            void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
            {

            }

            bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
            {
                //Get a reference to the right border position along the X-Axis for the LeftAreaUIElement
                if (parent.GetType().ToString() == "Infragistics.Win.UltraWinToolbars.ApplicationMenuLeftAreaUIElement")
                {
                    LeftToolsAreaRightBorder = parent.Rect.Right;
                }

                //Target only those TextEditorUIElements whose parent element is also a ToolEditorAreaUIElement; this will isolate the textEditor's that are used for the textBox as only these elements
                //are immeditately nested within the ToolEditorAreaUIElement
                if (parent.GetType().ToString() == "Infragistics.Win.EditorWithTextUIElement" && parent.Parent.GetType().ToString() == "Infragistics.Win.UltraWinToolbars.ToolEditorAreaUIElement")
                {
                    //Create a rectangle instance
                    Rectangle rect = new Rectangle();
                    //Assign the parent dimensions and position to the rectangle instance
                    rect = parent.Rect;
                    //Offset the rect position using the width of its parent container less the desired width of the textEditor, subtract 2 from this quantity
                    rect.X = LeftToolsAreaRightBorder - textEditorWidth - 2;
                    //Update the textEditor's width
                    rect.Width = textEditorWidth;
                    //Assign the parent rect's dimensions from the reference rect
                    parent.Rect = rect;
                }
                return false;
            }
        }
    }
}
